unit ColorIndexEditor;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, ColorPalette, StdCtrls, Buttons;

type
  TfrmColorIndexEditor = class(TForm)
    pbColors: TPaintBox;
    pbOK: TBitBtn;
    pbCancel: TBitBtn;
    Label1: TLabel;
    panelIndex: TPanel;
    shapeCursor: TShape;
    procedure FormActivate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure pbColorsPaint(Sender: TObject);
    procedure pbColorsMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormShow(Sender: TObject);
  private
    function GetPalette: HPALETTE; override;
  public
    nIndex: integer;
    pal: TColorPalette;
  end;

var
  frmColorIndexEditor: TfrmColorIndexEditor;

implementation

function TfrmCOlorIndexEditor.GetPalette: HPALETTE;
begin
  Result := pal.Palette;
end;

{$R *.DFM}

procedure TfrmColorIndexEditor.FormActivate(Sender: TObject);
begin
  SelectPalette( pbColors.Canvas.Handle, pal.Palette, FALSE );
  RealizePalette( pbColors.Canvas.Handle );
end;

procedure TfrmColorIndexEditor.Button1Click(Sender: TObject);
begin
  ModalResult := mrOk;
end;

procedure TfrmColorIndexEditor.pbColorsPaint(Sender: TObject);
var
  x, y: integer;
  rectFill: TRect;
begin
  SelectPalette( pbColors.Canvas.Handle, pal.Palette, FALSE );
  RealizePalette( pbColors.Canvas.Handle );
  with pbColors.Canvas do
     begin
        Brush.Style := bsSolid;
        for y := 0 to 15 do
           for x := 0 to 15 do
              begin
                 rectFill.Left := x * 16;
                 rectFill.Top := y * 16;
                 rectFill.Right := rectFill.Left + 15;
                 rectFill.Bottom := rectFill.Top + 15;
                 Brush.Color := PaletteIndex( y * 16 + x );
                 FillRect( rectFill );
              end;
        shapeCursor.Left := 8 + ( nIndex mod 16 ) * 16;
        shapeCursor.Top := 8 + ( nIndex div 16 ) * 16;
     end;
end;

procedure TfrmColorIndexEditor.pbColorsMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  nIndex := X div 16 + ( ( Y div 16 ) * 16 );
  panelIndex.Caption := IntToStr( nIndex );
  pbColorsPaint( self );
end;

procedure TfrmColorIndexEditor.FormShow(Sender: TObject);
begin
  panelIndex.Caption := IntToStr( nIndex );
end;

end.
